{-
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
-}
module CetaVerifier where {

import List;
import Xml;
import Util;
import ErrorMonad;
import Show;
import Term;
import Nat;
import ProofChecker;
import HOL;

eqWhiteSpace :: [Char] -> [Char] -> Bool;
eqWhiteSpace s1 s2 =
  filtera (\ c -> not (member c wspace)) s1 ==
    filtera (\ c -> not (member c wspace)) s2;

certifyProof :: [Char] -> [Char] -> Eithera [Char] [Char];
certifyProof trsString prfString =
  bind (parseXTCProblem trsString)
    (\ xtcProblem ->
      let {
        parsedTrsString = sshow_xtcProblem xtcProblem;
      } in bind (checkB (eqWhiteSpace trsString parsedTrsString)
                  (concata
                    ["the parsed TRS does not correspond to the input TRS",
                      newline, parsedTrsString]))
             (\ x ->
               let {
                 (XTCProblem xtcR metaInf) = xtcProblem;
                 (Xtctrs r sig comment) = xtcR;
               } in bind (parseProof prfString)
                      (\ a ->
                        (case a of {
                          Lefta termPrf ->
                            (case checkTRSProof r termPrf of {
                              Lefta err -> errora (showLista err);
                              Righta xa -> returna "CERTIFIED YES";
                            });
                          Righta nontermPrf ->
                            (case checkTRSDisproof r nontermPrf of {
                              Lefta err -> errora (showLista err);
                              Righta xa -> returna "CERTIFIED NO";
                            });
                        }))));

}
