(*
Copyright 2009 Christian Sternagel, René Thiemann, Sarah Winkler, Harald Zankl

This file is part of IsaFoR/CeTA.

IsaFoR/CeTA is free software: you can redistribute it and/or modify it under the
terms of the GNU Lesser General Public License as published by the Free Software
Foundation, either version 3 of the License, or (at your option) any later
version.

IsaFoR/CeTA is distributed in the hope that it will be useful, but WITHOUT ANY
WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A
PARTICULAR PURPOSE.  See the GNU Lesser General Public License for more details.

You should have received a copy of the GNU Lesser General Public License along
with IsaFoR/CeTA. If not, see <http://www.gnu.org/licenses/>.
*)
theory Ceta imports CetaVerifier Code_Char_chr (* Efficient_Nat *)
begin


code_instance unit :: eq
  (Haskell -)

(* outdated, these routines are for old Haskell input
export_code checkTRSProof checkTRSDisproof showList showTRS  in Haskell file "Haskell.ProofChecker" (string_classes)
*)

(* these axioms are required, since otherwise the code-generator is not able 
   to export these parser-functions *)
(* note that the correctness of certifyProof has already been proven without
   these axioms !! *)
(* RT: since I'm pretty sure, that all these functions are terminating:
       if someone has some spare time, go ahead and proof it *)
axioms parserTerminates: "(\<forall> x. parseAttributes_dom x) 
  \<and> (\<forall> x. parseXMLList_dom x) 
  \<and> (\<forall> x. xml2term_dom x) 
  \<and> (\<forall> x. xml2trsProof_dom x) 
  \<and> (\<forall> x. xml2dpProof_dom x) 
  \<and> (\<forall> x. xml2sharpTerm_dom x)
  \<and> (\<forall> x. xml2context_dom x)
  \<and> (\<forall> x. stripXMLHeader_dom x)"
termination parseAttributes by (simp add: parserTerminates)
termination parseXMLList by (simp add: parserTerminates)
termination xml2term by (simp add: parserTerminates)
termination xml2trsProof by (simp add: parserTerminates)
termination xml2dpProof by (simp add: parserTerminates)
termination xml2sharpTerm by (simp add: parserTerminates)
termination xml2context by (simp add: parserTerminates)
termination stripXMLHeader by (simp add: parserTerminates)

export_code certifyProof in Haskell file "CeTA.source"

end
